function [rand_b, finestres_ord2, w_b, rand_c, c, amplada_planta, w_AE, img4] = GenerarFacanaFinestres(np, nc, p, pisos, t, w_b, w_c, c, h_BA, c_baix, h_pis, h_prin, finestres_aux, finestres_ord2, im, h_b, pis_mig, pos_porta)
%{PRE::np>=0 numero de pisos que cal fer, nc>1 numero de finestres que cal
%fer, p: delimitacions de pisos(on comena i on acaba}, pisos>0, t: taula
%de finestres per pis, w_b: delimitacions de les finestres, w_c
%delimitacions de les espais entre finestres, c: delimitaci entre
%finestres, h_BA mida altura planta baixa, h_pis>0 altura del pis, h_prin
%altura del pis de l'imatge entrat per usuari, taula ordenada per h i te la
%mateix mida de l'amplada de totes sus finestres, taula ordenada per h,
%imatge entrat per usuari, h_b>0 , pis_mig>0, pos_porta>0}
%{POST::taula aleatoriament contingui les finestres, taula ordenada per h, w_b: delimitacions de les finestres verticalment, c: delimitacions de les espais 
       %entre finestres, w_AE: espai que hi ha en la part esquerre de la imatge, img4: imatge resultat}
ok = false;
rand_b = 0;
amplada_b = finestres_aux(1).BoundingBox(3);
if sum(t)-(sum(t(1:pisos))+1) > 1    
    finestres_ord3 = finestres_ord2;
    finestres_ord3(pos_porta) = [];
    ok = true;
end

%calculem l'amplada de la planta
amplada_c = w_c(1)+w_c(numel(w_c)); % sempre igual les parts AE i AD
for i=1:nc-1
    rand_c(i) = fix(((numel(c)/2)-2)*rand(1))+2; % numel(c)-2--> 2=AE+AD
    amplada_c = amplada_c + w_c(rand_c(i));
end
amplada_planta = nc*amplada_b + amplada_c;


%el que fem es comenar pel ultim pis despres el segon pis i adjuntem 
img3 = imresize(im, [h_pis+1 amplada_planta]);
w_AE = c(2)-c(1);
w_AD = c(numel(c))-c(numel(c)-1);


% Generar pisos i columnes
%Crear la imatge final
img4 = imresize(img3, [h_b*np+h_BA+2 amplada_planta]); 

% el primer bucles per fer plantes
h1_img = 1;
h2_img = 2;
h_pisInici = 1;
h_pisFi = 2;
img_T = dibuixarTerrat(h_pisInici, h_pisFi, amplada_planta);
imwrite(img_T,['objectes\t','.jpg']);
img4 = CopiarSubImatge(img4, img_T, h_pisInici, h_pisFi, 1, amplada_planta);
k = 1;
for i=1:np    
    h_pisInici = 1;
    h_pisFi = fix(h_b);
    w_pisInici = 1;
    w_pisFi = fix(w_AE);
   %fem la part AE que sempre es lo mateix igual que AD
    img_AE = transformarImatge(im, p(pis_mig), p(pis_mig)+h_pisFi-1, w_pisInici, w_pisFi);
    %img3(h_pisInici:h_pisFi, w_pisInici:w_pisFi) = img_AE(1:h_pisFi-h_pisInici+1, 1:w_pisFi-w_pisInici+1);   
    img3 = CopiarSubImatge(img3, img_AE, 1, h_pisFi-h_pisInici+1, 1, w_pisFi-w_pisInici+1);
    % el segon bucle es que esta fent es omplir la planta 
    for j=1:nc
        rand_b(k)= fix(sum(t(1:pisos))*rand(1))+1; %escollim una finestre al atzar                
        [h1 h2 w1 w2] =  PosarDades(finestres_aux, rand_b(k));    
        w2 = w1 + w2;
        w_pisInici = w_pisFi + 1;
        w_pisFi = w_pisFi + w_b; 
        img_b = transformarImatge(im, fix(h1), fix(h2), fix(w1), fix(w2));    
        mida = size(img_b);   
        img3 = CopiarSubImatge(img3, img_b, h_pisInici,h_pisFi, w_pisInici, w_pisFi);
        img3(h_pisInici:h_pisFi, w_pisInici:w_pisFi) = img_b(1:mida(1), 1:mida(2)); 
        %ara fem la part c o espai entre finestres
        if j ~= nc
            w_pisInici = w_pisFi + 1;
            mida = fix(w_c(rand_c(j)));
            w_pisFi = w_pisFi + mida;
            w1 = c(2*rand_c(j)-1);
            w2 = c(2*rand_c(j));
            img_c = transformarImatge(im, fix(h1), fix(h2), fix(w1), fix(w2));     
            img3 = CopiarSubImatge(img3, img_c, h_pisInici,h_pisFi, w_pisInici, w_pisFi);
        end
        k = k + 1;
    end
    %pasar la part AD
    w1 = c(numel(c)-1);
    w2 = w1 + (amplada_planta - w_pisFi)-1;    
    img_AD = transformarImatge(im, p(pis_mig), p(pis_mig+1), w1, w2);
    w_pisInici = w_pisFi + 1;
    w_pisFi = amplada_planta;
    img3 = CopiarSubImatge(img3, img_AD, h_pisInici, h_pisFi, w_pisInici, w_pisFi);
    % Ara el que fem es adjuntar el pis anterior amb el seguent
    h1_img = h2_img + 1;
    h2_img = h_pisFi*i+2;    
    img4 = CopiarSubImatge(img4, img3, h1_img, h2_img, 1, amplada_planta);   
end
%la planta baixa
hb_fi = size(img4, 1);
hb_inici = size(img4, 1) - h_BA + 1;
ant = 1;
pertany = true;
seg = 0;
volta = 1;
while pertany
    %fer la part d'espai esquerre AE   
    w1 = 1;
    w2 = fix(c_baix(2));
    if volta == 1
        seg = fix(seg + c_baix(2));
        img4 = ColocarSubImatge(img4, im, p, h_prin, w1, w2, ant, seg, hb_inici, hb_fi, amplada_planta);
        w1 = fix(w2) + 1;
        ant = fix(seg) + 1;                
    else 
        seg = ant + w2 -1;
        img4 = ColocarSubImatge(img4, im, p, h_prin, w1, w2, ant, seg, hb_inici, hb_fi, amplada_planta);
        w1 = fix(w2) + 1;
        ant = fix(seg) + 1;
    end
    j=sum(t(1:pisos))+1;
    k = 1; l = 2;
    if ~ok || volta == 1
      while j<=sum(t) && seg < amplada_planta
            %fer la part B si es pot 
            w2 = fix(finestres_ord2(j).BoundingBox(1) + finestres_ord2(j).BoundingBox(3)+1);
            if volta == 1            
                seg = fix(finestres_ord2(j).BoundingBox(1) + finestres_ord2(j).BoundingBox(3)+1); 
                img4 = ColocarSubImatge(img4, im, p, h_prin, w1, w2, ant, seg, hb_inici, hb_fi, amplada_planta);
            else            
                seg = fix(seg + finestres_ord2(j).BoundingBox(3) + 2);
                img4 = ColocarSubImatge(img4, im, p, h_prin, w1, w2, ant, seg, hb_inici, hb_fi, amplada_planta);
            end
            %escriure la part B
            w1 = w2 + 1;
            ant = seg + 1;
            %fer la part d'espai
            k = k + 1;
            w2 = fix(c_baix(2*k));
            if volta ==1            
                seg = fix(c_baix(2*k));
            else             
                seg = seg + (w2-w1)+1;
            end
            if seg < amplada_planta
                %espai = transformarImatge(im, p(numel(p))+1, h_prin, ant, seg);    
                img4 = ColocarSubImatge(img4, im, p, h_prin, w1, w2, ant, seg, hb_inici, hb_fi, amplada_planta);
                w1 = w2 + 1;
                ant = seg + 1;
            else 
                pertany = false;
            end   
            j = j + 1; 
            l = l + 1;
        end    
    end
   
     while ok && j<sum(t) && seg < amplada_planta && volta > 1
        %fer la part B si es pot 
        w1 = fix(finestres_ord3(j).BoundingBox(1));
        w2 = fix(finestres_ord3(j).BoundingBox(1) + finestres_ord3(j).BoundingBox(3)+1);           
        seg = fix(seg + finestres_ord3(j).BoundingBox(3) + 2);
        img4 = ColocarSubImatge(img4, im, p, h_prin, w1, w2, ant, seg, hb_inici, hb_fi, amplada_planta);
        %escriure la part B
        w1 = w2 + 1;
        ant = seg + 1;
        %fer la part d'espai
        k = k + 1;
        w1 = fix(c_baix(2*k-1));
        w2 = fix(c_baix(2*k));
        seg = seg + (w2-w1)+1;        
        if seg < amplada_planta
            %espai = transformarImatge(im, p(numel(p))+1, h_prin, ant, seg);    
            img4 = ColocarSubImatge(img4, im, p, h_prin, w1, w2, ant, seg, hb_inici, hb_fi, amplada_planta);
            w1 = w2 + 1;
            ant = seg + 1;
        else 
            pertany = false;
        end   
        j = j + 1; 
        l = l + 1;
    end   
    if seg > amplada_planta
        pertany = false;   % si la mida es inferior del tro que volem reemplaar lo en l'imatge
    end
    volta = volta + 1;
end

%cerquem la max de la c per substituir lo en la resta dreta de l'imatge 
max = 0;
index = 1;
for i=1:numel(c_baix)/2
    w = fix((c_baix(2*i)-c_baix(2*i-1)+1));
    if max < w 
        max = w;
        index = i;
    end
end
w1 = fix(ant)-1;
w2 = fix(amplada_planta);
D = w2 - w1;
w2_f = fix(c_baix(index*2));
w1_f = w2_f - D;
espai = transformarImatge(im, p(numel(p))+1, h_prin, w1_f, w2_f);
%img4(hb_inici:hb_fi, w1:w2) = espai(1:size(espai,1), 1:size(espai,2));
img4 = CopiarSubImatge(img4, espai, hb_inici, hb_fi, w1, w2);
end