clear all   %% netejar totes les variables de la memria
%%--------------------------------------------------------%%
%                    PRIMERA PART                          %
%%--------------------------------------------------------%%

%Obrir la imatge i guardar la en img
img=imread('C:\Users\rachid\Desktop\proves_PIL\Projecte\src\imatges\p1.jpg');
im = img; 
np = 1;   %np >=0
nc = 5;   %nc >=2

%crear una carpeta dentre del directori del codi, per guardar els components trobats
mkdir objectes;



%% Convertir en imatge binria
llindar = graythresh(img);    % troba la llindar
img =~im2bw(img,llindar);    % Crea una imatge binria a partir d'una imatge d'intensitat,
                             % imatge indexada o RGB basat en un llindar de luminncia.

%% Eliminar tots els objectes que continguin menys de 30 pxels
img = bwareaopen(img,200);

%% Etiqueta components relacionats
[L Ne]=bwlabel(img);

%% Mesura de les propietats de les regions de la imatge
propied=regionprops(L,'BoundingBox');
%propied2=regionprops(L, 'Image'); 
area_objectes=regionprops(L, 'Area');


%% guardar les finestres en una taula de finestres que te w_inici h_inici
%% amb Delta_w i Delta_h 
finestres = propied;
%%exemples finestres(1,1).BoundingBox = w h Dw Dh  el que fem es comparar w
%%si son iguals vull dir que estan en la mateixa columna, i comparar h si
%%son iguals vull dir que estan en la mateixa planta aixi podem calcular el
%%numero de finestres per planta i per columna

total_obj = propied;    % fem una copia a les objectes trobats
[h_prin w_prin] =  size(im); %la mida de l'imatge principal 

%% Eliminem el terrat de la imatge
[finestres area_objectes] = EliminarTerrat(finestres, area_objectes, w_prin);



%pos_porta = DefinirPosicioPorta(finestres);


%% eliminem les parts que tenen area mes petita que la media por 7 vegades
[area_objectes finestres] = EliminarAreasIndesitjables(area_objectes, finestres);



%%Ordinar la taula per altura h, y comptem quantes vegades les altura son
%%iguales ens dona el numero de finestres per planta
finestres_ord = finestres; %fer una copia a la taula finestres
finestres_ord = DefinirNumeroFinestresPerPis(finestres_ord);


%% calcular el numero de pisos que n'hi ha, es a dir si hi ha diferencia de
%% altura de mes de 10 pixel aixo implica que estem en altre pis
[pisos, t] = DefinirNumeroPisos(finestres_ord);


%% el que fem ara es detectar el pis on comena i on acaba aixi lo fem
%% despres del primer objecte trobat que es terrat fins la finestre.
[p h_ant h_inici] = DelimitarPisos(finestres, total_obj, finestres_ord, pisos, t);


% Definir la planta baixa
BA = transformarImatge(im, h_ant, h_prin, 1, w_prin/3);
[h_BA w_BA] = size(BA);
finestres_ord2 = finestres_ord;  %fer una copia de la taula finestres_ord

%% en aquesta part cerquem les columnes
%ordinar la taula per amplada w, ja esta ordinada per altura h
finestres_ord2= OrdenarPerAmplada(finestres_ord2, pisos, t);

% Dilimatar la part de textura esquerre AE
%w_min = DilimitarTexturaEsquerre(finestres_ord2, t);

%% Difinir taula  [(w_min1,w_max1), (w_min2,w_max2),...] aixo el que queda
%% es la part B
df = TrobarMinMaxFinestresPerColumna(finestres_ord2, pisos, t);


%% Trobar la part Bi, guardem en la taula b les w_inici i w_fi
b = DelimitarFinestresVerticalment(t, df);

%% Trobar les parts Ci
c = DelimitarEspaiEntreFinestres(b, w_prin);
    

%ordinar les finestres de la planta baixa
finestres_ord2 = OrdinarObjectesPlantaBaixa(finestres_ord2, pisos, t);


%%--------------------------------------------------------%%
%                    SEGONA PART                           %
%%--------------------------------------------------------%%

 
%% La mida de la nova imatge depend del numero de pisos i columnes entrat
%% per teclats
w_AD = c(numel(c))-c(numel(c)-1);
w_prin2 = w_prin - w_AD*3; 
%fem una copia al nostre imatge
img_aux = transformarImatge(im, fix(h_inici), fix(h_prin), 1, fix(w_prin2/3));

% Escollir el pis del mig, i guardar la seva longitud per fer els pisos seguents
% amb la mateixa longitud
if numel(p)>2
    pis_mig = fix(numel(p)/4); %escollir el pis del mig
    if mod(pis_mig,2) == 0   
        pis_mig = pis_mig - 1;
    end
else
    pis_mig = 1;
end
if pis_mig>1
    h_pis = fix(p(pis_mig+1)-p(pis_mig));
else
    h_pis = fix(p(2)-p(1));
end


%Trobar la distancia entre el inici del pis fins l'inici de la finestre h1,
%i la distancia de la final de la finestre al final del pis
[h_subDalt h_subBaix Dw] = TrobarSubAlturaPisFinestre(p, t, pis_mig, finestres_ord2);

% Trobar la posicio de la porta
pos_porta = PosicioPorta(finestres_ord2, pisos, t);

%Trobar la altura de la finestre per igualar amb totes finestres restant
h_fin = h_pis - (h_subDalt+h_subBaix);

%Igualar totes les finestres igual a la finestres que hem trobat abans
finestres_aux = finestres_ord2;
for i=1:sum(t)
    if i ~= pos_porta
        finestres_aux(i).BoundingBox(3) = Dw;
        finestres_aux(i).BoundingBox(4) = h_fin;
    end
end


%%--------------------------------------------------------%%
%                    TERCERA PART                          %
%%--------------------------------------------------------%%

%Guardar les finestres amb la mateix distancia entre finestre i textura
for i=1:sum(t(1:pisos))
    h1 = finestres_aux(i).BoundingBox(2) - h_subDalt;
    if h1<1 
        h1 = 1;
    end
    h2 = finestres_aux(i).BoundingBox(2) + finestres_aux(i).BoundingBox(4) + h_subBaix;
    finestres_aux(i).BoundingBox(2) = h1;
    finestres_aux(i).BoundingBox(4) = h2;
    w = finestres_aux(i).BoundingBox(1);
    W = w + finestres_aux(i).BoundingBox(3);
    FIN = transformarImatge(im, fix(h1), fix(h2), fix(w), fix(W));
    imwrite(FIN,['objectes\f',num2str(i),'.jpg']);
end
[h_b w_b] = size(FIN);
w_b = w_b/3;

%guardar les finestres i la porta de la planta baixa
h1 = p(numel(p));  % on comenca la planta baixa
i = sum(t(1:pisos)) + 1;
while i <= sum(t)
        w = finestres_aux(i).BoundingBox(1);
        W = w + finestres_aux(i).BoundingBox(3); 
        if W > w_prin/3
            W = w_prin/3;
        end
        FIN = transformarImatge(im, fix(h1), fix(h_prin), fix(w), fix(W));
        if i ~= pos_porta
            imwrite(FIN,['objectes\f',num2str(i),'.jpg']);    
        else
            imwrite(FIN,['objectes\p',num2str(i),'.jpg']); 
        end
        i = i + 1;
end

%guardem la cobertura o el terrat de la faana
if h_inici > 1
    img_cobertura = transformarImatge(im, 1, h_inici, 1, w_prin/3);
    imwrite(img_cobertura,['objectes\t_orginal','.jpg']); 
end

%guardar les parts c o espai entre finestres
altura_pis = finestres_aux(1).BoundingBox(3) + h_subBaix + h_subDalt;
h1 = p(pis_mig);
h2 = p(pis_mig+1);
for i=1:numel(c)/2
    espai = transformarImatge(im, fix(h1), fix(h2), fix(c(2*i-1)), fix(c(2*i)));
    imwrite(espai,['objectes\c',num2str(i),'.jpg']); 
    %guardem la mida exacta de cada espai
    [h_c(i) w_c(i)] = size(espai);    
end
w_c = w_c/3;


%guardar les parts c de la planta baixa
w1 = 1;
j = 1;
for i=sum(t(1:pisos))+1:sum(t)
    w2= fix(finestres_ord2(i).BoundingBox(1)-1);
    c_baix(2*j-1) = w1;
    c_baix(2*j) = w2;
    espai = transformarImatge(im, fix(p(numel(p))+1), fix(h_prin), w1, w2);
    imwrite(espai,['objectes\cb',num2str(j),'.jpg']); 
    w1 = fix(w2 + finestres_ord2(i).BoundingBox(3)+1);
    j = j + 1;
end
%fer l'ultim tro
c_baix(2*j-1) = w1 + 1;
c_baix(2*j) = fix(w_prin/3);
espai = transformarImatge(im, p(numel(p))+1, h_prin, w1+1, w_prin/3);
imwrite(espai,['objectes\cb',num2str(j),'.jpg']); 


%%--------------------------------------------------------%%
%                    QUARTA PART                           %
%%--------------------------------------------------------%%

%%GENERAR LA SORTIDA .TXT DE LA FAANA ORIGINAL
%% ESCRIURE LES PARTS D'IMATGE ORIGINAL DE FORMA EXPLICITA COMENANT DE
%% DALT A BAIX

% crear arxiu per guardar de forma explicita i implicita
fid = fopen('sort_org_explicita.txt','w');
fid2 = fopen('sort_org_implicita.txt','w');
%COMENEM PER DALT
fid = GenerarFitxerExplicitOriginal(t, p, h_inici, h_pis, h_BA, w_prin, w_c, c_baix, pos_porta, finestres_ord2, pisos, fid);
fclose(fid);
fid2 = GenerarFitxerImplicitOriginal(t, p, h_inici, h_pis, h_BA, w_prin, w_c, c_baix, pos_porta, finestres_ord2, pisos, fid2);
fclose(fid2);

%% GENERAR SORTIDA .TXT DE FORMA EXPLICITA 
% crear arxiu per guardar de forma explicita

fid3 = fopen('sort_generat_explicita.txt','w');
fid4 = fopen('sort_generat_implicita.txt','w');
amplada_b = finestres_aux(1).BoundingBox(3);

%calculem l'amplada de la planta
amplada_c = w_c(1)+w_c(numel(w_c)); % sempre igual les parts AE i AD
for i=1:nc-1
    rand_c(i) = fix(((numel(c)/2)-2)*rand(1))+2; % numel(c)-2--> 2=AE+AD
    amplada_c = amplada_c + w_c(rand_c(i));
end
amplada_planta = nc*amplada_b + amplada_c;


%el que fem es comenar pel ultim pis despres el segon pis i adjuntem 
img3 = imresize(img_aux, [h_pis+1 amplada_planta]);
w_AE = c(2)-c(1);
w_AD = c(numel(c))-c(numel(c)-1);


% Generar pisos i columnes
%Crear la imatge final
img4 = imresize(img3, [h_b*np+h_BA+2 amplada_planta]); 

% el primer bucles per fer plantes
h1_img = 1;
h2_img = 2;

[rand_b, finestres2, wb, rand_c, cc, amplada_planta, w_AE, img4] = GenerarFacanaPortes(np, nc, p, pisos, t, w_b, w_c, c, h_BA, c_baix, h_pis, h_prin, finestres_aux, finestres_ord2, im, h_b, pis_mig, pos_porta);
%[rand_b, finestres2, wb, rand_c, cc, amplada_planta, w_AE, img4] = GenerarFacanaFinestres(np, nc, p, pisos, t, w_b, w_c, c, h_BA, c_baix, h_pis, h_prin, finestres_aux, finestres_ord2, im, h_b, pis_mig, pos_porta);
%fid3 = GenerarFacanaExplicit(h_pis, pos_porta, pisos, t, w_b, rand_c, rand_b, w_c, c, h_BA, c_baix, amplada_planta, w_AE, finestres_ord2, np, nc, fid3);
fid3 = GenerarFacanaFinestresExplicit(h_pis, pos_porta, pisos, t, w_b, rand_c, rand_b, w_c, c, h_BA, c_baix, amplada_planta, w_AE, finestres_ord2, np, nc, fid3);
%fid4 = GenerarFacanaImplicit(h_pis, pos_porta, pisos, t, w_b, rand_c, rand_b, w_c, c, h_BA, c_baix, amplada_planta, w_AE, finestres_ord2, np, nc, fid4);
fid4 = GenerarFacanaFinestresImplicit(h_pis, pos_porta, pisos, t, w_b, rand_c, rand_b, w_c, c, h_BA, c_baix, amplada_planta, w_AE, finestres_ord2, np, nc, fid4);

imshow(img4);   %Mostrar imatge en la finestre 
