function [p, pisos, t, w_b, w_c, c, h_BA, c_baix, h_inici, h_pis, h_prin, w_prin, finestres_aux, finestres_ord2, im, h_b, pis_mig, pos_porta] = VarialbesGlobals(img)
%{PRE::imatge de dimensions diferent de zero}
%{POST::retorna les variables que ens servira per cridar altres funcions: p delimitacions de pisos on comena i on acaba, pisos>0, t: taula
%de finestres per pis, w_b: delimitacions de les finestres, w_c delimitacions de les espais entre finestres,  c: delimitaci entre
%finestres, h_BA mida altura planta baixa, h_pis>0 altura del pis, h_prin
%altura del pis de l'imatge entrat per usuari, taula ordenada per h i te la
%mateix mida de l'amplada de totes sus finestres, taula ordenada per h,
%imatge entrat per usuari, h_b>0 , pis_mig>0, pos_porta>0}

im = img; % fer una copia a la imatge
%% Convertir en imatge binria
llindar = graythresh(img);    % troba la llindar
img =~im2bw(img,llindar);    % binaritza la imatge

%% Eliminar tots els objectes que continguin menys de 30 pxels
img = bwareaopen(img,200);

%% Etiqueta components relacionats
[L Ne]=bwlabel(img);

%% Mesura de les propietats de les regions de la imatge
propied=regionprops(L,'BoundingBox');
%propied2=regionprops(L, 'Image'); 
area_objectes=regionprops(L, 'Area');


%% guardar les finestres en una taula de finestres que te w_inici h_inici
%% amb Delta_w i Delta_h 
finestres = propied;
%%exemples finestres(1,1).BoundingBox = w h Dw Dh  el que fem es comparar w
%%si son iguals vull dir que estan en la mateixa columna, i comparar h si
%%son iguals vull dir que estan en la mateixa planta aixi podem calcular el
%%numero de finestres per planta i per columna

total_obj = propied;    % fem una copia a les objectes trobats
[h_prin w_prin] =  size(im); %la mida de l'imatge principal 

%% Eliminem el terrat de la imatge
[finestres area_objectes] = EliminarTerrat(finestres, area_objectes, w_prin);



%pos_porta = DefinirPosicioPorta(finestres);


%% eliminem les parts que tenen area mes petita que la media por 7 vegades
[area_objectes finestres] = EliminarAreasIndesitjables(area_objectes, finestres);



%%Ordinar la taula per altura h, y comptem quantes vegades les altura son
%%iguales ens dona el numero de finestres per planta
finestres_ord = finestres; %fer una copia a la taula finestres
finestres_ord = DefinirNumeroFinestresPerPis(finestres_ord);


%% calcular el numero de pisos que n'hi ha, es a dir si hi ha diferencia de
%% altura de mes de 10 pixel aixo implica que estem en altre pis
[pisos, t] = DefinirNumeroPisos(finestres_ord);


%% el que fem ara es detectar el pis on comena i on acaba aixi lo fem
%% despres del primer objecte trobat que es terrat fins la finestre.
[p h_ant h_inici] = DelimitarPisos(finestres, total_obj, finestres_ord, pisos, t);


% Definir la planta baixa
BA = transformarImatge(im, h_ant, h_prin, 1, w_prin/3);
[h_BA w_BA] = size(BA);
finestres_ord2 = finestres_ord;  %fer una copia de la taula finestres_ord

%% en aquesta part cerquem les columnes
%ordinar la taula per amplada w, ja esta ordinada per altura h
finestres_ord2= OrdenarPerAmplada(finestres_ord2, pisos, t);

% Dilimatar la part de textura esquerre AE
%w_min = DilimitarTexturaEsquerre(finestres_ord2, t);

%% Difinir taula  [(w_min1,w_max1), (w_min2,w_max2),...] aixo el que queda
%% es la part B
df = TrobarMinMaxFinestresPerColumna(finestres_ord2, pisos, t);


%% Trobar la part Bi, guardem en la taula b les w_inici i w_fi
b = DelimitarFinestresVerticalment(t, df);

%% Trobar les parts Ci
c = DelimitarEspaiEntreFinestres(b, w_prin);
    

%ordinar les finestres de la planta baixa
finestres_ord2 = OrdinarObjectesPlantaBaixa(finestres_ord2, pisos, t);


%%--------------------------------------------------------%%
%                    SEGONA PART                           %
%%--------------------------------------------------------%%

 
%% La mida de la nova imatge depend del numero de pisos i columnes entrat
%% per teclats
w_AD = c(numel(c))-c(numel(c)-1);
w_prin2 = w_prin - w_AD*3; 
%fem una copia al nostre imatge
img_aux = transformarImatge(im, fix(h_inici), fix(h_prin), 1, fix(w_prin2/3));

% Escollir el pis del mig, i guardar la seva longitud per fer els pisos seguents
% amb la mateixa longitud
if numel(p)>2
    pis_mig = fix(numel(p)/4); %escollir el pis del mig
    if mod(pis_mig,2) == 0   
        pis_mig = pis_mig - 1;
    end
else
    pis_mig = 1;
end
if pis_mig>1
    h_pis = fix(p(pis_mig+1)-p(pis_mig));
else
    h_pis = fix(p(2)-p(1));
end


%Trobar la distancia entre el inici del pis fins l'inici de la finestre h1,
%i la distancia de la final de la finestre al final del pis
[h_subDalt h_subBaix Dw] = TrobarSubAlturaPisFinestre(p, t, pis_mig, finestres_ord2);

% Trobar la posicio de la porta
pos_porta = PosicioPorta(finestres_ord2, pisos, t);

%Trobar la altura de la finestre per igualar amb totes finestres restant
h_fin = h_pis - (h_subDalt+h_subBaix);

%Igualar totes les finestres igual a la finestres que hem trobat abans
finestres_aux = finestres_ord2;
for i=1:sum(t)
    if i ~= pos_porta
        finestres_aux(i).BoundingBox(3) = Dw;
        finestres_aux(i).BoundingBox(4) = h_fin;
    end
end


%%--------------------------------------------------------%%
%                    TERCERA PART                          %
%%--------------------------------------------------------%%

%Guardar les finestres amb la mateix distancia entre finestre i textura
for i=1:sum(t(1:pisos))
    h1 = finestres_aux(i).BoundingBox(2) - h_subDalt;
    h2 = finestres_aux(i).BoundingBox(2) + finestres_aux(i).BoundingBox(4) + h_subBaix;
    finestres_aux(i).BoundingBox(2) = h1;
    finestres_aux(i).BoundingBox(4) = h2;
    w = finestres_aux(i).BoundingBox(1);
    W = w + finestres_aux(i).BoundingBox(3);
    FIN = transformarImatge(im, fix(h1), fix(h2), fix(w), fix(W));
    imwrite(FIN,['objectes\f',num2str(i),'.jpg']);
end
[h_b w_b] = size(FIN);
w_b = w_b/3;

%guardar les finestres i la porta de la planta baixa
h1 = p(numel(p));  % on comenca la planta baixa
i = sum(t(1:pisos)) + 1;
while i <= sum(t)
        w = finestres_aux(i).BoundingBox(1);
        W = w + finestres_aux(i).BoundingBox(3);       
        FIN = transformarImatge(im, fix(h1), fix(h_prin), fix(w), fix(W));
        if i ~= pos_porta
            imwrite(FIN,['objectes\f',num2str(i),'.jpg']);    
        else
            imwrite(FIN,['objectes\p',num2str(i),'.jpg']); 
        end
        i = i + 1;
end

%guardem la cobertura o el terrat de la faana
if h_inici > 1
    img_cobertura = transformarImatge(im, 1, h_inici, 1, w_prin/3);
    imwrite(img_cobertura,['objectes\t_orginal','.jpg']); 
end

%guardar les parts c o espai entre finestres
altura_pis = finestres_aux(1).BoundingBox(3) + h_subBaix + h_subDalt;
h1 = p(pis_mig);
h2 = p(pis_mig+1);
for i=1:numel(c)/2
    espai = transformarImatge(im, fix(h1), fix(h2), fix(c(2*i-1)), fix(c(2*i)));
    imwrite(espai,['objectes\c',num2str(i),'.jpg']); 
    %guardem la mida exacta de cada espai
    [h_c(i) w_c(i)] = size(espai);    
end
w_c = w_c/3;


%try


%guardar les parts c de la planta baixa
w1 = 1;
j = 1;
for i=sum(t(1:pisos))+1:sum(t)
    w2= fix(finestres_ord2(i).BoundingBox(1)-1);
    c_baix(2*j-1) = w1;
    c_baix(2*j) = w2;
    espai = transformarImatge(im, fix(p(numel(p))+1), fix(h_prin), w1, w2);
    imwrite(espai,['objectes\cb',num2str(j),'.jpg']); 
    w1 = fix(w2 + finestres_ord2(i).BoundingBox(3)+1);
    j = j + 1;
end
%fer l'ultim tro
c_baix(2*j-1) = w1 + 1;
c_baix(2*j) = fix(w_prin/3);
espai = transformarImatge(im, p(numel(p))+1, h_prin, w1+1, w_prin/3);
imwrite(espai,['objectes\cb',num2str(j),'.jpg']); 

end